package sun.rmi.server;

import java.rmi.server.RMIClassLoader;
import sun.rmi.transport.Target;
import sun.rmi.transport.ObjectTable;
import java.rmi.server.RemoteStub;
import java.rmi.Remote;
import java.security.AccessController;
import java.security.PrivilegedAction;
import java.io.IOException;
import java.io.OutputStream;
import java.io.ObjectOutputStream;

public class MarshalOutputStream extends ObjectOutputStream
{
    public MarshalOutputStream(OutputStream outputStream) throws IOException {
        this(outputStream, 1);
    }
    
    public MarshalOutputStream(OutputStream out, int version) throws IOException {
        super(out);
        this.useProtocolVersion(version);
        AccessController.doPrivileged(new PrivilegedAction<Void>() {
            @Override
            public Void run() {
                MarshalOutputStream.access$000(MarshalOutputStream.this, true);
                return null;
            }
        });
    }
    
    @Override
    protected final Object replaceObject(Object o) throws IOException {
        if (o instanceof Remote && !(o instanceof RemoteStub)) {
            Target target = ObjectTable.getTarget((Remote)o);
            if (target != null) {
                return target.getStub();
            }
        }
        return o;
    }
    
    @Override
    protected void annotateClass(Class<?> cl) throws IOException {
        this.writeLocation(RMIClassLoader.getClassAnnotation(cl));
    }
    
    @Override
    protected void annotateProxyClass(Class<?> clazz) throws IOException {
        this.annotateClass(clazz);
    }
    
    protected void writeLocation(String obj) throws IOException {
        this.writeObject(obj);
    }
    
    static boolean access$000(MarshalOutputStream marshalOutputStream, boolean enable) throws SecurityException {
        return marshalOutputStream.enableReplaceObject(enable);
    }
}
